TWatershed< dim > Class Template Reference
Filtering and combining

templated version of the standard watershed algorithm More...

`#include <mia/template/watershed.hh>`

Inherits watershed_traits::Handler::Product.

## Public Types

typedef Handler::Product | CFilter
typedef CFilter::Image | CImage
typedef watershed_traits< dim >::Handler | Handler
typedef PNeighbourhood::element_type::value_type | MPosition
typedef CFilter::Pointer | PFilter
typedef CImage::Pointer | PImage
typedef watershed_traits< dim >::PNeighbourhood | PNeighbourhood
typedef CImage::dimsize_type | Position

## Public Member Functions

template<template< typename > class Image, typename T>
TWatershed< dim >::result_type | operator() (const Image< T > &data) const
| TWatershed (PNeighbourhood neighborhood, bool with_borders, float treash, bool eval_grad)

## Friends

bool | operator< (const PixelWithLocation &lhs, const PixelWithLocation &rhs)

## Detailed Description

template<int dim>
class TWatershed< dim >

templated version of the standard watershed algorithm

Template Parameters

  dim | Dimension for the input images

Definition at line 35 of file watershed.hh.

## Member Typedef Documentation

## CFilter

template<int dim>

typedef Handler::Product TWatershed< dim >::CFilter

Definition at line 41 of file watershed.hh.

## CImage

template<int dim>

typedef CFilter::Image TWatershed< dim >::CImage

Definition at line 43 of file watershed.hh.

## Handler

template<int dim>

typedef watershed_traits<dim>::Handler TWatershed< dim >::Handler

Definition at line 40 of file watershed.hh.

## MPosition

template<int dim>

typedef PNeighbourhood::element_type::value_type TWatershed< dim >::MPosition

Definition at line 39 of file watershed.hh.

## PFilter

template<int dim>

typedef CFilter::Pointer TWatershed< dim >::PFilter

Definition at line 42 of file watershed.hh.

## PImage

template<int dim>

typedef CImage::Pointer TWatershed< dim >::PImage

Definition at line 44 of file watershed.hh.

## PNeighbourhood

template<int dim>

typedef watershed_traits<dim>::PNeighbourhood TWatershed< dim >::PNeighbourhood

Definition at line 38 of file watershed.hh.

## Position

template<int dim>

typedef CImage::dimsize_type TWatershed< dim >::Position

Definition at line 45 of file watershed.hh.

## Constructor & Destructor Documentation

## TWatershed()

template<int dim>

TWatershed< dim >::TWatershed | ( | PNeighbourhood | neighborhood,
|  | bool | with_borders,
|  | float | treash,
|  | bool | eval_grad )

Definition at line 98 of file watershed.hh.

Referenced by operator()().

## Member Function Documentation

## operator()()

template<int dim>
template<template< typename > class Image, typename T>

TWatershed< dim >::result_type TWatershed< dim >::operator() | ( | const Image< T > & | data | ) | const

Definition at line 221 of file watershed.hh.

References boundary_label, cvdebug(), cvmsg(), and TWatershed().

## Friends And Related Symbol Documentation

## operator<

template<int dim>

bool operator< | ( | const PixelWithLocation & | lhs,
|  | const PixelWithLocation & | rhs )

friend

Definition at line 63 of file watershed.hh.

The documentation for this class was generated from the following file:

- watershed.hh